library ieee;
use ieee.std_logic_1164.all;

entity deco2a4 is
  port(enable: in std_logic;
        x: in std_logic_vector(1 downto 0);
        y: out std_logic_vector(3 downto 0));
end deco2a4;

architecture puertas of deco2a4 is
signal not_x0, not_x1: std_logic;
begin
  inv_1: entity work.not1 port map(x(0), not_x0);
  inv_2: entity work.not1 port map(x(1), not_x1);
  and_1: entity work.and3 port map(enable, not_x0, not_x1, y(0));
  and_2: entity work.and3 port map(enable, x(0), not_x1, y(1));
  and_3: entity work.and3 port map(enable, not_x0, x(1), y(2));
  and_4: entity work.and3 port map(enable, x(0), x(1), y(3));
end puertas;


library ieee;
use ieee.std_logic_1164.all;

entity test_deco2a4 is end test_deco2a4;

architecture test of test_deco2a4 is

signal enable: std_logic;
signal x: std_logic_vector(1 downto 0) := "00";
signal y: std_logic_vector(3 downto 0);

begin

inst_1: entity work.deco2a4(puertas) port map(enable, x, y);
enable <= '0', '1' after 400 ns;
x(0) <= not x(0) after 50 ns;
x(1) <= not x(1) after 100 ns;

end test;