library ieee;
use ieee.std_logic_1164.all;

entity add4 is
  port(a,b: in std_logic_vector(3 downto 0);
       cin: in std_logic;
       s:   out std_logic_vector(3 downto 0);
       cout:out std_logic);
end add4;

architecture estructural of add4 is
signal c: std_logic_vector(4 downto 0);
begin
  c(0) <= cin;
  sum0: entity work.add1 port map(a(0), b(0), c(0), s(0), c(1));
  sum1: entity work.add1 port map(a(1), b(1), c(1), s(1), c(2));
  sum2: entity work.add1 port map(a(2), b(2), c(2), s(2), c(3));
  sum3: entity work.add1 port map(a(3), b(3), c(3), s(3), c(4));
  cout <= c(4);
end estructural;

architecture estructural_2 of add4 is
signal c: std_logic_vector(4 downto 0);
begin
  c(0) <= cin;
sum4: for i in 0 to 3 generate
        sum: entity work.add1 port map(a(i), b(i), c(i), s(i), c(i+1));
      end generate;
  cout <= c(4);
end estructural_2;

--------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity test_add4 is
end test_add4;

architecture test of test_add4 is
signal a, b, s: std_logic_vector(3 downto 0);
signal cin, cout: std_logic;
begin
  inst: entity work.add4 port map(a, b, cin, s, cout);
  a <= "0001", "1010" after 10 ns, "0110" after 20 ns, "1101" after 30 ns;
  b <= "0010", "0101" after 10 ns, "0011" after 20 ns, "0110" after 30 ns;
  cin <= '0', '1' after 5 ns, '0' after 15 ns, '1' after 25 ns;
end test;