library ieee;
use ieee.std_logic_1164.all;

entity addn is
  generic(n: integer);
  port(a,b: in std_logic_vector(n-1 downto 0);
       cin: in std_logic;
       s:   out std_logic_vector(n-1 downto 0);
       cout:out std_logic);
end addn;

architecture estructural of addn is
signal c: std_logic_vector(n downto 0);
begin
  c(0) <= cin;
sum4: for i in 0 to n-1 generate
        sum: entity work.add1 port map(a(i), b(i), c(i), s(i), c(i+1));
      end generate;
  cout <= c(n);
end estructural;

------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity test_addn is
end test_addn;

architecture test of test_addn is
signal a,b,s: std_logic_vector(7 downto 0);
signal cin, cout: std_logic;
begin
  cin <= '0', '1' after 100 ns;
  a <= conv_std_logic_vector(123,8), conv_std_logic_vector(63,8) after 50 ns;
  b <= conv_std_logic_vector(31,8);
  inst_1: entity work.addn generic map(8) port map(a,b,cin,s,cout);
end test;

