library ieee;
use ieee.std_logic_1164.all;

entity cod8a3 is
  port(enable: in std_logic;
       x: in std_logic_vector(7 downto 0);
       y: out std_logic_vector(2 downto 0);
       activo: out std_logic);
end cod8a3;

architecture puertas of cod8a3 is
signal s0,s1,s2,s3: std_logic;
begin
  or1: entity work.or4 port map(x(1),x(3),x(5),x(7),s0);
  or2: entity work.or4 port map(x(2),x(3),x(6),x(7),s1);
  or3: entity work.or4 port map(x(4),x(5),x(6),x(7),s2);
  or4: entity work.or8 port map(x(0),x(1),x(2),x(3),x(4),x(5),x(6),x(7),s3);
  and1: entity work.and2 port map(s0,enable,y(0));
  and2: entity work.and2 port map(s1,enable,y(1));
  and3: entity work.and2 port map(s2,enable,y(2));
  and4: entity work.and2 port map(s3,enable,activo);
end puertas;

architecture concurrente of cod8a3 is
begin
  y(0) <= enable and (x(1) or x(3) or x(5) or x(7));
  y(1) <= enable and (x(2) or x(3) or x(6) or x(7));
  y(2) <= enable and (x(4) or x(5) or x(6) or x(7));
  activo <= enable and (x(0) or x(1) or x(2) or x(3) or x(4) or
            x(5) or x(6) or x(7));
end concurrente;
------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity test_cod8a3 is
end test_cod8a3;

architecture test of test_cod8a3 is
signal x: std_logic_vector(7 downto 0);
signal enable, activo: std_logic;
signal y: std_logic_vector(2 downto 0);
begin
  inst1: entity work.cod8a3(concurrente) port map(enable,x,y,activo);
  enable <= '0', '1' after 25 ns;
  x <= "00000000", "00100000" after 10 ns, "00000100" after 20 ns, 
       "00000010" after 30 ns, "10000000" after 40 ns, "00000001" after 50 ns,
       "00000000" after 60 ns;
end test;