library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity demux1a4 is
  port(enable, x: in std_logic;
       sel: in std_logic_vector(1 downto 0);
       y: out std_logic_vector(3 downto 0));
end demux1a4;

architecture concurrente of demux1a4 is
begin
  y(0) <= enable and x and (not sel(0)) and (not sel(1));
  y(1) <= enable and x and sel(0) and (not sel(1));
  y(2) <= enable and x and (not sel(0)) and sel(1);
  y(3) <= enable and x and sel(0) and sel(1);
end concurrente;

architecture funcional_1 of demux1a4 is
begin
  process(enable, x, sel)
    begin
      y <= "0000";
      if enable = '1' then
        case sel is
          when "00" => y(0) <= x;
          when "01" => y(1) <= x;
          when "10" => y(2) <= x;
          when others => y(3) <= x;
        end case;
      end if;
    end process;
end funcional_1;

architecture funcional_2 of demux1a4 is
begin
  process(enable, x, sel)
  begin
    y <= "0000";
    if enable = '1' then
      y(conv_integer(sel)) <= x;
    end if;
  end process;
end funcional_2;

----------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity test_demux1a4 is
end test_demux1a4;

architecture test of test_demux1a4 is
signal enable: std_logic;
signal x: std_logic := '0';
signal sel: std_logic_vector(1 downto 0);
signal y1, y2, y3: std_logic_vector(3 downto 0);
begin
  inst1: entity work.demux1a4(concurrente) port map(enable, x, sel, y1);
  inst2: entity work.demux1a4(funcional_1) port map(enable, x, sel, y2);
  inst3: entity work.demux1a4(funcional_2) port map(enable, x, sel, y3);
  
  enable <= '1', '0' after 200 ns;
  x <= not x after 5 ns;
  sel <= "00", "01" after 50 ns, "10" after 100 ns, "11" after 150 ns;
end test;