
library ieee;
use ieee.std_logic_1164.all;

entity ejemploFSM_JK is
  port(clk,rst,x: in std_logic;
       z: out std_logic);
end ejemploFSM_JK;

architecture estructural of ejemploFSM_JK is
signal J0, K0, J1, K1, S0, S1: std_logic;
begin
  J0 <= not x;
  K0 <= x;
  J1 <= x and S0;
  K1 <= '1';
  Z  <= x and S1;
  
  ff_0: entity work.flipflopJK port map(clk,rst,J0,K0,S0);
  ff_1: entity work.flipflopJK port map(clk,rst,J1,K1,S1);
end estructural;

------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity test_ejemploFSM_JK is
end test_ejemploFSM_JK;

architecture test of test_ejemploFSM_JK is
signal clk: std_logic := '0';
signal rst,x,z: std_logic;
begin
  clk <= not clk after 5 ns;
  rst <= '0', '1' after 10 ns, '0' after 20 ns;
  x <= '1', '0' after 30 ns,'1' after 60 ns, '0' after 70 ns, '1' after 80 ns;
  inst: entity work.ejemploFSM_JK port map(clk,rst,x,z);
end test;