library ieee;
use ieee.std_logic_1164.all;

entity ejemplo_and_or_not is
  port(x: in std_logic_vector(3 downto 0);
       z: out std_logic);
end ejemplo_and_or_not;

architecture arq_1 of ejemplo_and_or_not is
signal s0, s1, s2, s3: std_logic;
signal not_x0, not_x1, not_x2, not_x3: std_logic;
begin
  inv_0: entity work.not1 port map(x(0), not_x0);
  inv_1: entity work.not1 port map(x(1), not_x1);
  inv_2: entity work.not1 port map(x(2), not_x2);
  inv_3: entity work.not1 port map(x(3), not_x3);
  puerta0: entity work.and3 port map(a => x(3), b => not_x2, c => not_x0, z => s0);
  puerta1: entity work.and3 port map(not_x3, x(2), not_x1, s1);
  puerta2: entity work.and4 port map(x(3), x(2), x(1), x(0), s2);
  puerta3: entity work.and3 port map(x(3), not_x1, not_x0, s3);
  puerta4: entity work.or4 port map(s0, s1, s2, s3, z);
end arq_1;

architecture arq_2 of ejemplo_and_or_not is
begin
  z <= ( x(3) and (not x(2)) and (not x(0)) ) or 
        ( (not x(3)) and x(2) and (not x(1)) ) or
        ( x(3) and x(2) and x(1) and x(0) ) or
        ( x(3) and (not x(1)) and (not x(0)) );
end arq_2;

library ieee;
use ieee.std_logic_1164.all;

entity test_ejemplo_and_or_not is end test_ejemplo_and_or_not;
architecture test of test_ejemplo_and_or_not is
signal x: std_logic_vector(3 downto 0) := "0000";
signal z: std_logic;
begin
  x(0) <= not x(0) after 5 ns;
  x(1) <= not x(1) after 10 ns;
  x(2) <= not x(2) after 20 ns;
  x(3) <= not x(3) after 40 ns;
  inst_1: entity work.ejemplo_and_or_not port map(x,z);
end;
