
library ieee;
use ieee.std_logic_1164.all;

entity fsm_funcional is
  port(clk,rst,x: in std_logic;
       z: out std_logic);
end fsm_funcional;

architecture funcional of fsm_funcional is
type estados is (S0, S1, S2);
signal ns, ps: estados;
begin
  --proximo estado y salida
  process(x,ps)
    begin
      case ps is
        when S0 => if x = '0' then ns <= S1; z <= '0';
                   else ns <= S0; z <= '0';
                   end if;
        when S1 => if x = '0' then ns <= S1; z <= '0';
                   else ns <= S2; z <= '0';
                   end if;
        when S2 => if x = '0' then ns <= S1; z <= '0';
                   else ns <= S0; z <= '1';
                   end if;
      end case;
    end process;
    --actualizacin del estado
    process(clk,rst)
      begin
        if rst = '1' then
          ps <= S0;
        elsif rising_edge(clk) then
          ps <= ns;
        end if;
      end process;
        
end funcional;


-------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity test_fsm_funcional is
end test_fsm_funcional;

architecture test of test_fsm_funcional is
signal clk: std_logic := '0';
signal rst,x,z: std_logic;
begin
  clk <= not clk after 5 ns;
  rst <= '0', '1' after 10 ns, '0' after 20 ns;
  x <= '1', '0' after 30 ns,'1' after 60 ns, '0' after 70 ns, '1' after 80 ns;
  inst: entity work.fsm_funcional port map(clk,rst,x,z);
end test;
