library ieee;
use ieee.std_logic_1164.all;

entity reg_load_oe is
  generic(width: integer);
  port(clk, rst, load, oe: in std_logic;
       I: in std_logic_vector(width-1 downto 0);
       Q: out std_logic_vector(width-1 downto 0));
end reg_load_oe;

architecture funcional of reg_load_oe is
signal Q_aux: std_logic_vector(width-1 downto 0);
begin
  --Escritura:
  process(clk,rst)
    begin
      if rst = '1' then
        Q_aux <= (others => '0');
      elsif (rising_edge(clk) and load = '1') then
        Q_aux <= I;
      end if;
    end process;
  --Lectura  
  process(Q_aux, oe)
    begin
      if oe = '1' then
        Q <= Q_aux;
      else
        Q <= (others => 'Z');
      end if;
    end process;
end funcional;

-------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity test_reg_load_oe is
end test_reg_load_oe;

architecture test of test_reg_load_oe is
signal clk: std_logic := '0'; 
signal rst, load, oe: std_logic;
signal I, Q: std_logic_vector(3 downto 0);
begin
  clk <= not clk after 5 ns;
  rst <= '0', '1' after 20 ns, '0' after 22 ns;
  load <= '0', '1' after 50 ns, '0' after 60 ns, '1' after 100 ns, '0' after 110 ns;
  oe <= '0', '1' after 70 ns;
  I <= "0110", "1001" after 40 ns, "1111" after 80 ns;
  inst: entity work.reg_load_oe generic map(4) port map(clk, rst, load, oe, I, Q);
  
end test;