library ieee;
use ieee.std_logic_1164.all;

entity sintesis_mux is
  port(a,b,c,d: in std_logic;
       z: out std_logic);
end sintesis_mux;

architecture arq_1 of sintesis_mux is
signal E: std_logic_vector(3 downto 0);
signal sel: std_logic_vector(1 downto 0);
begin
  E(0) <= (not a) and b;
  E(1) <= (not b);
  E(2) <= a or b;
  E(3) <= (not a) or (not b);
  sel(0) <= d;
  sel(1) <= c;
  mux: entity work.mux4a1(funcional) port map('1', E, sel, z);
end arq_1;

architecture arq_2 of sintesis_mux is
signal E: std_logic_vector(3 downto 0);
signal sel: std_logic_vector(1 downto 0);
begin
  E(0) <= b;
  E(1) <= (not b) or c;
  E(2) <= c;
  E(3) <= (not b);
  sel(0) <= d;
  sel(1) <= a;
  mux: entity work.mux4a1(concurrente) port map('1', E, sel, z);
end arq_2;

--------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity test_sintesis_mux is
end test_sintesis_mux;

architecture test of test_sintesis_mux is
signal a: std_logic := '0';
signal b: std_logic := '0';
signal c: std_logic := '0';
signal d: std_logic := '0';
signal z1, z2: std_logic;
begin
  inst_1: entity work.sintesis_mux(arq_1) port map(a,b,c,d,z1);
  inst_2: entity work.sintesis_mux(arq_2) port map(a,b,c,d,z2);
  d <= not d after 2 ns;
  c <= not c after 4 ns;
  b <= not b after 8 ns;
  a <= not a after 16 ns;  
end test;